#ifndef BOARD_H
#define BOARD_H

#include "config.h"
#include "object.h"
#include "stdio.h"

typedef enum {
	pointsKill,       //pocet zabitych superov
	pointsDead,       //pocet vlastnych umrti
	pointsFired,      //pocet vystrelenych striel
	pointsHitTank,    //pocet zasahov seperov
	pointsHitGround,  //mnozstvo odburanej zeminy
	pointsHitMissile, //mnozstvo zostrelenych striel
	pointsWeightGround,//body za zeminu. Cim dalej zere zeminu od domceka, tym ma viac bodov
	pointsPointsAll,
	pointsCount
} Points;

extern char pointsDesc[pointsCount][20];

class Board {
public:
	Board( int _width, int _height, int _turns, bool enableGui);
	virtual ~Board();
	
	void fillGround();  //vyplni volne miesto zeminou
	
//vrati objekt na danej pozicii
	Object* get(const Point &p);

//vymaze z danej pozicii objekt (neuvolni!). Urcene pre destructor toho objektu
	void clear(const Point &p);
//zasadi na danu poziciu objekt o
	void put(const Point &p, Object *o);

	int width() {return widthProp;};
	int height() {return heightProp;};

//vypise vyrez do suboru
	void printState(FILE *f, Point bp);

	void freeFreeList();
	void addToFreeList( Object * o);

	virtual void addObject( Object *o );  //prida aktivny objekt. Objekt my ho "putneme"

	int run();

	FILE * fGui() { return fGuiProp; };
	int turns() { return turnsProp; };
	void setPlayers(int x) { players=x;};
	
	int points[MAX_PLAYERS+1][pointsCount];
	
private:
	PObject map[MAX_BOARD_SIZE][MAX_BOARD_SIZE];
	int widthProp, heightProp;
	int turnsProp;  //kolko casu do konca?
	int players;

//zoznam objektov cakajucich na uvolnenie z pamate
	ObjectList freeList;
//zoznam aktivnych objektov
	ObjectList active;

	FILE *fGuiProp;   //fifo na komunikaciu sa gui
};

#endif //BOARD_H
