#include "board.h"
#include "objects.h"

static int players=2;

typedef FILE *PFILE;
PFILE fgui, ftoplayer[MAX_PLAYERS], ffromplayer[MAX_PLAYERS];

void closeFifos()
{
	if (fgui) fclose(fgui);
	for (int i=0; i<players; i++) {
	}
}

bool openFifos()
{
	bool ok=true;

	fgui=0;
//	ok = ok && fgui;


	return ok;
}

//vytvori domcek so stredom p a umiestni do neho hraca
void createHomeTank( Point p, Board *b, int number)
{
	Object *home = new ObjHome( p, b, number);
	home->putToBoard();

	ObjTank *tank= new ObjTank(p, b, number );
	b->addObject(tank);
}

//inicializuje plan. Rozmiestnenie hracov vezme z mapy
Board * initBoard(char *mapName)
{
	FILE *fmap = fopen(mapName,"r");
	if (!fmap) {
		fprintf(stderr,"Neporadilo sa otvorit subor %s s mapou\n",mapName);
		exit(1);
	}
		
	int w,h,turns, enableGui;
	fscanf(fmap, "%d %d %d %d", &w, &h, &turns, &enableGui);

	Board *b= new Board(w, h, turns, enableGui);

	players=0;
	while (players<MAX_PLAYERS) {
		int x,y;
		fscanf(fmap, "%d %d",&x, &y);
		if (x<0 || y<0) break;
		
		players++;
		createHomeTank( Point(x,y), b, players);
	}
	b->setPlayers(players);
	
	b->fillGround();

	return b;
}

int main(int argc, char **argv)
{
	char *fname="map";
	if (argc>1) 
		fname = argv[1];

	Board *b = initBoard(fname);

	printf("Hra zacina\n");
	b->run();

	printf("Statistika:\n");
	for (int i=0; i<pointsCount; i++) {
		printf("%-20s : ", pointsDesc[i]);
		for (int j=1; j<=MAX_PLAYERS; j++)
			printf("%4d ", b->points[j][i]);
		putchar('\n');
	}

	{
		FILE *log = fopen("log.txt","a");
		if (log) {			
			for (int j=1; j<=MAX_PLAYERS; j++)
				fprintf(log, "%4d ", b->points[j][pointsPointsAll]);
			fprintf(log, "\n");
		}
		fclose(log);
	}

	delete b;

	return 0;
}
