#include "object.h"
#include "board.h"
#include "types.h"
#include <assert.h>
#include <stdio.h>

Point::Point( int _x, int _y)
{
	x=_x; y=_y;
}

Point::Point( PointStruct p)
{
	x=p.x, y=p.y;
}
// *********************   Object  *********************

Object::Object(Point _bp, Board *_board, int _type)
{
	static int lastId=1;
	idProp=lastId++;
		
	bpProp=_bp;
	typeProp=_type;
	deletedProp=false;

	assert(_board);
	board=_board;
}

Object::~Object()
{
	assert(isDeleted());

	if (board->fGui()) {
		fprintf(board->fGui(), "%d %d %d %d %s %d\n", id(), type(), -1, -1, "DELETED", 0);
		fflush(board->fGui()); 
	}
}

void Object::step()
{
}

void Object::putToBoard()
{
	assert(board);
	board->put(bp(), this);
	onBoardProp=1;
	

	putToGui(); 
//	fprintf(stderr,"Object put to board - %s at %d %d\n",typyNazvy[type()], bp().x, bp().y);
}

void Object::removeFromBoard()
{
	board->clear(bp());
	onBoardProp=0;
}

char Object::getCode( Point )
{
	return typyKod[type()];
}

void Object::setDeleted()
{
	if (isDeleted()) return;

	removeFromBoard();
	board->addToFreeList(this);
	deletedProp=true;

}

void Object::hit(int)
{
}
