unit player;
interface
uses types;

procedure init;
procedure done;
procedure novyStav( const s:TStav);
function vratTah:integer;
function mamStrelit:boolean;

//hlaska nesmie obsahovat obsahovat znaky noveho riadku
function vratHlasku:string;

implementation
uses linux, sysutils,
     config;

const PREHLADAVANIE=0; 
      HUNT=1;
      RUN_FOOL=2;  {ked nema EN}
                  
      
      MAX_CIEL=100;
      KRIZ=15;
      MAX_CUVAJ=10;

var lastNow : TDateTime;
    mapa : array[-MAX_BOARD_SIZE..MAX_BOARD_SIZE, 
    		-MAX_BOARD_SIZE..MAX_BOARD_SIZE] of char;    
    domy : array[0..MAX_PLAYERS] of TDom;
    tanky : array[0..MAX_PLAYERS] of TTank;
    domov, tankov : integer;
    stav : TStav;
    mode,prev_mode : integer;
    ciel : TPoint;
    faza : integer; {faza prehladavania}
    old : TPoint; {stare suradnice, ak sa nezmenia, tak sa tam neda ist}  
    stuck : boolean; {priznak, ze sme sa chceli pohnut, ale ostali sme stat}
    prev_move : integer;
    start_preh : TPoint;
    utek : boolean;
    cuvaj : integer;
    
    

function now_msec:double;
var hour, min, sec, msec : word;
begin
  getTime(hour, min, sec, msec);
  now_msec:= date + (hour*60*60 + min*60 + sec + msec/100.0)/(24*60*60);
end;

procedure init;
var i,j : integer;
begin
//  InitVideo;
  prev_mode := PREHLADAVANIE;
  mode := PREHLADAVANIE;
  for i := -MAX_BOARD_SIZE to MAX_BOARD_SIZE do
   for j := -MAX_BOARD_SIZE to MAX_BOARD_SIZE do mapa[i,j] := '.';
  for i := 1 to MAX_PLAYERS do 
   begin
    tanky[i].number := -1;
    domy[i].number := -1;
   end; 
  lastNow:=now_msec;  
  stuck := false;
  prev_move := TP_TAH_NIC;
  cuvaj := MAX_CUVAJ;
  utek := false;
  faza := 0;
  old.x := 0;
  old.y := 0;
end;

procedure done;
begin
  //DoneVideo;
end;

procedure save_view;
  var i,j,x,y,d:integer;
      c:char;
begin
  d:=STAV_STRANA div 2;
  for i:=1 to STAV_STRANA do
  begin
    for j:=1 to STAV_STRANA do 
    begin
      c:=stav.vidim[j][i];
      x:= stav.domov.x-d+i-1;
      y:= stav.domov.y-d+j-1;
      case c of
        'a'..'n','x',' ','#':mapa[x][y]:=c;  
	'1'..'9','/','\','|','-':
		if not (mapa[x][y] in ['a'..'n'])then mapa[x][y]:=' ';
      end;
    end;
  end;
  for i := 1 to stav.objekty_pocet do
   begin
    case stav.objekty[i].typ of
     objTank:
      begin
       tanky[stav.objekty[i].tank.number] := stav.objekty[i].tank;
      end;
     objDom:
      begin       
       domy[stav.objekty[i].dom.number] := stav.objekty[i].dom;
      end;
    end;  
   end;
end;

procedure novyStav( const s:TStav);
const farba:array[1..5]of byte=(9,11,13,14,15);
var pis_y, i, j : integer;
    f : text;
begin  
  //delay(100);
  stav := s;
  save_view;  
  with stav do begin 
    {SetCursorPos( 1,0 );
    writeln(' Cas ',cas:4);
    for i:=1 to STAV_STRANA do begin
      for j:=1 to STAV_STRANA do
      begin
        case vidim[i][j] of
	  'x':begin
	        textcolor(6);
	      end; 
	  'a'..'n':begin
	             textcolor(10);
		   end;

	  '1'..'9':begin 
	             textcolor(farba[ord(vidim[i][j])-48]);
		   end; 
	  '-','/','\','|':begin
	                    textcolor(12);
			  end;  
	  '#': textcolor(15);
	end;
        write(vidim[i][j]);
      end;	
      writeln;      
    end;
    textcolor(7);
    pis_y:=1;
    for i:=1 to objekty_pocet do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      case objekty[i].typ of
        objTank   :
          with objekty[i].tank do begin
            writeln('Hrac ',number,':  poz ',poz.x:3,',',poz.y:3,'  smer ',dir,'  spi ',spi,'       ');
            SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
            writeln('         EN ',en:4,'  HP ',hp:4,'  striel ', striel,'          ');
          end;
        objStrela :
          with objekty[i].strela do
            writeln('Strela : pos ',poz.x:3,',',poz.y:3, '  smer ',dir,'  vlastnik ',number,'           ');
        objDom :
          with objekty[i].dom do
            writeln('Dom ',number,': pos ',poz.x:3,',',poz.y:3, '  vlastnik ',number,'           ');
        else
          writeln('Neosetreny objekt                                        ');
      end;
    end;
    for i:=objekty_pocet to STAV_STRANA+1 do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      writeln('                                              ');
    end;

  SetCursorPos(1, STAV_STRANA+2);
  
  with stav.ja do 
    writeln('EN ',en:4,'  HP ',hp:4, '  spi ',spi:2, '  striel ',striel:2, '                   ');
  
  writeln(' domov ',domov.x:3,', ',domov.y:3, '                          ');
 }
  end;
  {for i:= -10 to 10 do 
    for j := -10 to 10 do
     begin
      SetCursorPos(i+30+11,j+11);
      write(mapa[i][j]);
     end;    
  while (now_msec<=(lastNow+0.05/(24*60*60))) do delay(10);
  lastNow:=now_msec;}
end; 

function rotate(point:TPoint):integer;
  var x,y,smer:integer;
begin
  x:=stav.domov.x;
  y:=stav.domov.y;
  if point.x = x then 
   begin
    if point.y < y then smer :=0 
    else smer := 4;
   end
  else if point.y = y then 
   begin
    if point.x > x then smer :=2
    else smer := 6;
   end
  else 
   begin
    if point.x > x then 
     begin
      if point.y < y then smer := 1
      else smer := 3;    
     end
    else  
     begin
      if  point.y < y then smer := 7
      else smer := 5;
     end;
     end;
   if (smer=stav.ja.dir){or((stav.domov.x=point.x)and(stav.domov.y=point.y))} then rotate := -1 else
   if 4 < abs(8-smer+stav.ja.dir) mod 8 then 
     rotate:=TP_TAH_DOPRAVA
   else rotate := TP_TAH_DOLAVA;
   {SetCursorPos(20,26);
   writeln(smer);}
end;

function move_to(point:TPoint):integer;
var x,y,px,py,tah:integer;
begin
  tah := TP_TAH_NIC;
  x:=stav.domov.x;
  y:=stav.domov.y;
  tah:=rotate(point);
  case stav.ja.dir of
   1,2,3 : px := 3;
   0,4 : px := 0;
   5,6,7 : px := -3;
  end; 
  case stav.ja.dir of
   7,0,1 : py := -3;
   6,2 : py := 0;
   5,4,3 : py := 3;
  end;
  if tah = -1 then
  begin
    if ((x = point.x) and (y = point.y))or stuck then 
      tah := -1
    else tah := TP_TAH_DOPREDU;
  end;  
  {SetCursorPos(20,27);
  write('move_to:',tah);}
  move_to := tah;
end;

function mode_prehladavanie: integer;
var tah,i : integer;
begin
 if faza = 0 then 
  begin
   start_preh := stav.domov;
   ciel.x := start_preh.x+KRIZ;
   ciel.y := start_preh.y+KRIZ;
   inc(faza);
  end;  
 mode_prehladavanie := TP_TAH_NIC;
 tah := move_to(ciel);
 if tah = -1 then 
  begin
   case faza of
    1: 
     begin
      ciel.x := start_preh.x-KRIZ;
      ciel.y := start_preh.y-KRIZ;
     end;   
    2:
     begin
      ciel.x := start_preh.x;
      ciel.y := start_preh.y;
     end;
    3:
     begin
      ciel.x := start_preh.x+KRIZ;
      ciel.y := start_preh.y-KRIZ;
     end;
    4: 
      begin
       ciel.x := start_preh.x-KRIZ;
       ciel.y := start_preh.y+KRIZ;
      end; 
    5: 
     begin
      randomize;
      ciel.x := start_preh.x+random(300)-150;
      ciel.y := start_preh.x+random(300)-150;
      dec(faza);
     end;
   end;
   inc(faza);
  end
 else mode_prehladavanie := tah; 
end;

function mode_hunt: integer;
var i,minsh,tah : integer;
begin
 if utek and (cuvaj > 0) then 
  begin
   dec(cuvaj);
  end
 else
  begin
   utek := false;
   cuvaj := MAX_CUVAJ;
  end;
{ SetCursorPos(10,27);
 write('Hunt mode');}
 tah := TP_TAH_NIC;
 minsh := TANK_HP+1;
 for i := 1 to stav.objekty_pocet do
  begin
   with stav.objekty[i] do
    begin
     if typ = objTank then 
      begin
       if tank.number <> stav.ja.number then 
         if minsh>tank.hp then
        begin
	  minsh:=tank.hp;	  
	  ciel.x:=stav.domov.x+tank.poz.x;
	  ciel.y:=stav.domov.y+tank.poz.y;
	end;  
      end  {ak je to tank}
     else if typ=objDom then
      begin
       if dom.number <> stav.ja.number then 
        utek := true;
      end;
    end; {with}
  end; {for cez objekty}
  {ciel.x := stav.domov.x + stav.objekty[finded].tank.poz.x;
  ciel.y := stav.domov.y + stav.objekty[finded].tank.poz.y;}
  tah := move_to(ciel);
  if utek then tah := TP_TAH_DOZADU; 
  if tah = -1 then 
   begin
    tah := TP_TAH_NIC;    
   end;  
  mode_hunt := tah;
end;

function mode_run:integer;
var tah : integer;
begin
  ciel.x:=0;
  ciel.y:=0;
  tah := move_to(ciel);
  if tah <> -1 then mode_run := tah;
end;

function vratTah:integer;
var i: integer;    	
    tah : integer;
begin  
  {delay(50);}
  mode := PREHLADAVANIE;
  tah := TP_TAH_NIC;
  {if prev_mode = HUNT then mode := HUNT
  else mode := PREHLADAVANIE;}
  if (old.x=stav.domov.x)and(old.y=stav.domov.y)
     and((prev_move=TP_TAH_DOPREDU) or (prev_move=TP_TAH_DOZADU) or (prev_move=TP_TAH_NIC)) then stuck := true     
  else  stuck := false;
  for i := 1 to stav.objekty_pocet do
   begin
    with stav.objekty[i] do
     begin
      case typ of
       objTank:
        begin
         if tank.number <> stav.ja.number then
	  begin
	   mode := HUNT;
	   {SetCursorPos(0,27);
	   write('Hunt mode');}
	  end;
        end;
       objDom:
        begin
        end;
       objStrela: 
        begin
	 
        end;
      end;  
     end;
   end; 
  if not (mode = HUNT) then
  begin
   if ((mode = PREHLADAVANIE) or (mode=RUN_FOOL)) and 
      ((stav.ja.en < (abs(stav.domov.x)+abs(stav.domov.y))*50) 
      or (stav.ja.hp < TANK_HP div 3)) then mode:= RUN_FOOL;
   if (prev_mode = RUN_FOOL)  and ((stav.ja.en < TANK_EN) or (stav.ja.hp < TANK_HP)) then mode := RUN_FOOL;
  end;
  case mode of   
   PREHLADAVANIE: 
     begin
       if prev_mode <> PREHLADAVANIE then faza := 0;
       tah := mode_prehladavanie;       
     end;
   HUNT: tah := mode_hunt;
   RUN_FOOL: tah:= mode_run;
  end;
  {SetCursorPos(20,27);
  writeln(tah);
  SetCursorPos(20,28);
  write(old.x,' : ',old.y);
  write(' mode:',mode,' prev_mode: ',prev_mode);
  SetCursorPos(10,28);
  writeln(ciel.x:2,' : ',ciel.y:2);}
  vratTah := tah;
  prev_move := tah;
  if (tah = TP_TAH_DOPREDU) or (tah = TP_TAH_DOZADU) then 
   begin
    old.x := stav.domov.x;
    old.y := stav.domov.y;
   end;
  prev_mode := mode; 
end;

function strel_hunt:boolean;
var sx,sy,i :integer;
    strel : boolean;	
begin
 strel_hunt := false;
  case stav.ja.dir of
    0:begin sx:=0;sy:=-1; end;
    1:begin sx:=1;sy:=-1; end;
    2:begin sx:=1;sy:=0; end;
    3:begin sx:=1;sy:=1; end;
    4:begin sx:=0;sy:=1; end;
    5:begin sx:=-1;sy:=1; end;
    6:begin sx:=-1;sy:=0; end;
    7:begin sx:=-1;sy:=-1; end;
   end;
  for i:=0 to 9 do
    if (stav.vidim[i*sx,i*sy] in ['1'..'9'])then strel_hunt:=true;
end;

function mamStrelit:boolean;
begin 
 {case stav.ja.dir }
 case mode of
   HUNT: 
       begin
         mamStrelit:=true;{strel_hunt;}
       end;
 end;
end;

function vratHlasku:string;
const hlasky : array[0..2,0..4] of string = (
	('Kde ste, hlupaci?','Bojite sa?','Ocuravam rohy','Error, enemies seems to be too weak, I dont fight with childs!','Preco to robi ten krizik?'),
	('Teraz to schytas!','So mnou si si nemal zacinat!','Umri na ploche nohy','Skap do rana','Za narod, za vlast, za KSP!!!'),
	('Nohy na plecia','F1,F1,F1! Help!','Daj pokoj, ved je to len hra','Runtime error in enemy tank','See you later!'));
	
var h : integer;
begin
 vratHlasku := '';
 {if random(3)=0 then
  begin
   h := random(5);
   vratHlasku:=hlasky[mode][h];
  end;}
end;

end.
