program textplayer;
uses config, types, player,
     sysutils;

var fin, fout : text;
    player_number:integer;

procedure openFifos;
var x:integer;
begin
  val(paramstr(1), player_number, x);

  assign(fin,format(FTOPLAYER_NAME, [player_number])); 
  reset(fin);

  assign(fout,format(FFROMPLAYER_NAME, [player_number])); 
  rewrite(fout);
end;

procedure closeFifos;
begin
  close(fin);
  close(fout);
end;

procedure readState(var stav:TStav);
var i,j,x:integer;
begin
  with stav do begin
    readln(fin, domov.x, domov.y);
    readln(fin, cas);
    readln(fin, hracov);
    
    //nacitaj mapku
    for i:=1 to STAV_STRANA do begin
      for j:=1 to STAV_STRANA do
        read(fin, vidim[i][j]);
      readln(fin);
    end;
    readln(fin); //za mapou je jeden volny riadok

    objekty_pocet:=0;
    repeat
      read(fin, x);
      if x=ord(objKoniec) then break;

      inc(objekty_pocet);
      objekty[objekty_pocet].typ:=TypyObjektov(x);
      case objekty[objekty_pocet].typ of
        objTank   : begin
          with objekty[objekty_pocet].tank do
            readln(fin, id, poz.x, poz.y, dir, number, en, hp, spi, striel);
          if objekty[objekty_pocet].tank.number=player_number then
            ja:=objekty[objekty_pocet].tank;
        end;
        objStrela :
          with objekty[objekty_pocet].strela do
            readln(fin, id, poz.x, poz.y, dir, number);
        objDom :
          with objekty[objekty_pocet].dom do
            readln(fin, id, poz.x, poz.y, number);
      end;
    until false;
  end;

  writeln(fout, vratHlasku);
  flush(fout);
end;


procedure sendMove;
var x:integer;
begin
  x:=vratTah;
  if x<0 then x:=0;
  if x>=TP_TAH_POCET then x:=0;
  writeln(fout, x);
  flush(fout);
end;

procedure sendFire;
begin
  if mamStrelit then
    writeln(fout, TP_VYSTREL_STRELIT)
  else
    writeln(fout, TP_VYSTREL_NIC);
  
  flush(fout);
end;


var x:integer;
    stav:TStav;
begin
  if paramcount()<1 then begin
    writeln('Usage: ');
    writeln(' textplayer number');
    writeln();
    writeln(' fifos should be in the current directory');
    writeln;
    exit;
  end;

  openFifos();
  init;

  while ( (not eof(fin))  ) do begin
    
    readln(fin, x );
//    writeln(stderr, x);

    if (x=FP_KONIEC) then break;
    case x of
      FP_STAV       : begin readState(stav); novyStav(stav); end;
      FP_TAHAJ      : sendMove;
      FP_VYSTRELIT_ : sendFire;
    end;
  end;

  closeFifos;
end.

