#ifndef		_HAVE_HEAP_H
#define		_HAVE_HEAP_H


#define		HEAP_MALLOC		128


struct Heap
{
  void **base;
  u_int32_t count;
  u_int32_t alloc;
  int32_t (*cmp) (void *, void *);
  void (*del) (void *);
};


struct Heap *heap_new(int32_t (*) (void *, void *), void (*) (void *));
void heap_up(struct Heap *, u_int32_t);
void heap_down(struct Heap *, u_int32_t);
void heap_free(struct Heap *);
void heap_insert(struct Heap *, void *);
void *heap_extract(struct Heap *);
void heap_delete(struct Heap *);


#endif		/* _HAVE_HEAP_H */
