#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "player.h"
#include "heap.h"

#define _sleep(x)
#define _printf(x, y...)

// #define _sleep(x) sleep(x)
// #define _printf(x, y...) printf(x, ## y)

#ifndef TANK_EN_DOPREDU
# define TANK_EN_DOPREDU TANK_EN_DODPREDU
#endif

typedef int dis_pole[2*MAX_BOARD_SIZE+50][2*MAX_BOARD_SIZE+50][8];

enum {
  smerS,
  smerSV,
  smerV,
  smerJV,
  smerJ,
  smerJZ,
  smerZ,
  smerSZ,
  smerPocet
};


int tankTvary[smerPocet][5][5] = { {

{0,0,1,0,0},
{0,1,1,1,0},
{0,1,1,1,0},
{0,1,1,1,0},
{0,1,1,1,0},

},{
{0,0,0,1,1},
{0,0,1,1,1},
{0,1,1,1,0},
{1,1,1,0,0},
{0,1,0,0,0},

},{
{0,0,0,0,0},
{1,1,1,1,0},
{1,1,1,1,1},
{1,1,1,1,0},
{0,0,0,0,0},

},{
{0,1,0,0,0},
{1,1,1,0,0},
{0,1,1,1,0},
{0,0,1,1,1},
{0,0,0,1,1},

},{
{0,1,1,1,0},
{0,1,1,1,0},
{0,1,1,1,0},
{0,1,1,1,0},
{0,0,1,0,0},

},{
{0,0,0,1,0},
{0,0,1,1,1},
{0,1,1,1,0},
{1,1,1,0,0},
{1,1,0,0,0},
},{
{0,0,0,0,0},
{0,1,1,1,1},
{1,1,1,1,1},
{0,1,1,1,1},
{0,0,0,0,0},

},{
{1,1,0,0,0},
{1,1,1,0,0},
{0,1,1,1,0},
{0,0,1,1,1},
{0,0,0,1,0},

} };


struct Policko
{
  int where;
  int x, y, dir;
  int en;
  int t;
  int prvytah, tah;
  double val;
};



int smer_x[8]={ 0, 1, 1, 1, 0, -1, -1, -1 };
int smer_y[8]={ -1, -1, 0, 1, 1, 1, 0, -1 };



#define		M_NEVIEM	'?'
#define		M_PL		'0'
#define		M_DOM		('a'-1)
#define		M_TRAVA		'x'
#define		M_NIC		' '
#define		M_OKRAJ		'#'

#define		STAV_HLADANIE	0
#define		STAV_UTOK	1
#define		STAV_DOMCEK	2


static char pole_mapa[2*MAX_BOARD_SIZE+50][2*MAX_BOARD_SIZE+50];
static int pole_hraci[2*MAX_BOARD_SIZE+50][2*MAX_BOARD_SIZE+50][MAX_PLAYERS+1];
static int pole_mozme[2*MAX_BOARD_SIZE+50][2*MAX_BOARD_SIZE+50];
static struct TDom hraci_dom[MAX_PLAYERS+1];
static struct TTank hraci_kde[MAX_PLAYERS+1];
static int hraci_kedy[MAX_PLAYERS+1];
static int stav_hry;
static struct TPoint *ciel;
static dis_pole ciel_cesta;
static int ciel_dir;
static struct TTank *ja;
static int return_en;
static int mapa_zmena;
static struct TTank *enemy;
static int cas;


#define MAPA(x,y) pole_mapa[MAX_BOARD_SIZE+(x)+25][MAX_BOARD_SIZE+(y)+25]
#define HRACI(x,y,z) pole_hraci[MAX_BOARD_SIZE+(x)+25][MAX_BOARD_SIZE+(y)+25][z]
#define MOZME(x,y) pole_mozme[MAX_BOARD_SIZE+(x)+25][MAX_BOARD_SIZE+(y)+25]
#define FORMAPA(i,j) \
	for(i=-MAX_BOARD_SIZE-25; i<MAX_BOARD_SIZE+25; i++) \
	  for(j=-MAX_BOARD_SIZE-25; j<MAX_BOARD_SIZE+25; j++)


void showmap()
{
  int x, y;
  
  for(y=-9; y<=9; y++)
  {
    for(x=-30; x<=30; x++)
      _printf("%c", MAPA(x+ja->poz.x,y+ja->poz.y));
    _printf("\n");
  }
}

void init(int x)
{
  int i, j, k;

  ja=&hraci_kde[player_number];
  stav_hry=STAV_HLADANIE;
  ciel=NULL;
  srand(x);
//  srand(time(NULL));
  FORMAPA(i,j)
    MAPA(i,j)=M_NEVIEM;
  FORMAPA(i,j)
    for(k=1; k<=MAX_PLAYERS; k++)
      HRACI(i,j, k)=0;
  FORMAPA(i,j)
    MOZME(i,j)=0;
  for(i=1; i<=MAX_PLAYERS; i++)
  {
    hraci_dom[i].number=0;
    hraci_kde[i].number=0;
    hraci_kedy[i]=1000000000;
  }
  return_en=TANK_EN;
  mapa_zmena=1;
}


void done()
{
  if(ciel)
    free(ciel);
}


int x_left=10000, x_up=10000;

void novyStav(struct TStav *stav)
{
  int i, j, k, l;
  char c, d;

  FORMAPA(i,j)
    if(MAPA(i,j)>M_PL && MAPA(i,j)<=M_PL+MAX_PLAYERS)
      MAPA(i,j)=M_NIC;


  cas=stav->cas;

  for(i=0; i<STAV_STRANA; i++)
    for(j=0; j<STAV_STRANA; j++)
  {
    if(i+stav->domov.x-STAV_STRANA/2<x_left)
      x_left=i+stav->domov.x-STAV_STRANA/2;
    if(j+stav->domov.y-STAV_STRANA/2<x_up)
      x_up=j+stav->domov.y-STAV_STRANA/2;

    c=MAPA(i+stav->domov.x-STAV_STRANA/2, j+stav->domov.y-STAV_STRANA/2);
    d=stav->vidim[j][i];
    
    if(d>M_PL && d<=M_PL+MAX_PLAYERS && d!=M_PL+player_number)
      mapa_zmena=1;
    
    if(d=='|' || d=='-' || d=='/' || d=='\\')
      mapa_zmena=1;
    
    if(c==M_NEVIEM && d!=M_NEVIEM)
      mapa_zmena=1;
    
    if(c==M_TRAVA && d!=M_TRAVA)
      mapa_zmena=1;

    MAPA(i+stav->domov.x-STAV_STRANA/2, j+stav->domov.y-STAV_STRANA/2)=stav->vidim[j][i];
    if(stav->vidim[j][i]>M_PL && stav->vidim[j][i]<=M_PL+MAX_PLAYERS)
      HRACI(i+stav->domov.x-STAV_STRANA/2, j+stav->domov.y-STAV_STRANA/2, stav->vidim[j][i]-M_PL)=stav->cas;
  }


  FORMAPA(i,j)
    MOZME(i,j)=MAPA(i,j)!=M_NEVIEM && (MAPA(i,j)<=M_DOM || MAPA(i,j)>M_DOM+MAX_PLAYERS || MAPA(i,j)==M_DOM+player_number);
  
  FORMAPA(i,j)
    if(MAPA(i,j)==M_OKRAJ || (MAPA(i,j)>M_PL && MAPA(i,j)<=M_PL+MAX_PLAYERS && MAPA(i,j)!=M_PL+player_number))
      for(k=-2; k<=2; k++)
        for(l=-2; l<=2; l++)
          MOZME(i+k, j+l)=0;

  for(i=0; i<stav->objekty_pocet; i++)
    switch(stav->objekty[i].typ)
  {
    struct TTank *tank;
    struct TDom *dom;

    case objTank:
      tank=&stav->objekty[i].obj.objTank;
      tank->poz.x=tank->poz.x+stav->domov.x;
      tank->poz.y=tank->poz.y+stav->domov.y;
      memcpy(&hraci_kde[tank->number], tank, sizeof(struct TTank));
      hraci_kedy[tank->number]=stav->cas;
      break;
    case objDom:
      dom=&stav->objekty[i].obj.objDom;
      dom->poz.x=dom->poz.x+stav->domov.x;
      dom->poz.y=dom->poz.y+stav->domov.y;
      memcpy(&hraci_dom[dom->number], dom, sizeof(struct TDom));
      break;
    case objStrela:
      break;
    default:
      _printf("Neznamy typ objektu.\n");
      break;
  }

  for(k=1; k<=MAX_PLAYERS; k++)
    if(hraci_dom[k].number)
      for(i=-4; i<=4; i++)
        for(j=-4; j<=4; j++)
          MAPA(hraci_dom[k].poz.x+i, hraci_dom[k].poz.y+j)=M_DOM+k;
}


int hl_cmp(void *a, void *b)
{
  struct Policko *p1=a;
  struct Policko *p2=b;
  
  if(p1->val<p2->val)
    return -1;

  return 1;
}


static struct Policko *pol[2*MAX_BOARD_SIZE+50][2*MAX_BOARD_SIZE+50][8];
dis_pole dis_en;
dis_pole dis_t;

void hl_insert(int x, int y, int dir, int en, int t, int prvytah, int tah, struct Heap *heap, double we, double wc)
{
  struct Policko *p;
  
  if(dis_en[x][y][dir]<1000000000)
    return;

  if(pol[x][y][dir] && we*(double)en+wc*(double)t<pol[x][y][dir]->val)
  {
    p=pol[x][y][dir];
    p->x=x;
    p->y=y;
    p->dir=dir;
    p->en=en;
    p->t=t;
    p->prvytah=prvytah;
    p->tah=tah;
    p->val=we*(double)en+wc*(double)t;
    
    heap_up(heap, p->where);
    
    return;
  }
  
  if(pol[x][y][dir])
    return;

  p=malloc(sizeof(struct Policko));
  p->x=x;
  p->y=y;
  p->dir=dir;
  p->en=en;
  p->t=t;
  p->prvytah=prvytah;
  p->tah=tah;
  p->val=we*(double)en+wc*(double)t;

  pol[x][y][dir]=p;
  heap_insert(heap, p);
}


int bager_en(int x, int y, int dir)
{
  int i, j, k=0;

  for(i=0; i<5; i++)
    for(j=0; j<5; j++)
      if(tankTvary[dir][j][i] && pole_mapa[x+i-2][y+j-2]==M_TRAVA)
        k+=TANK_EN_BAGER;

  return k;
}


int bager_t(int x, int y, int dir)
{
  int i, j, k=0;

  for(i=0; i<5; i++)
    for(j=0; j<5; j++)
      if(tankTvary[dir][j][i] && pole_mapa[x+i-2][y+j-2]==M_TRAVA)
        k+=TANK_CAS_BAGER;

  return k;
}


/* we*energia+wc*cas */
int hladaj(dis_pole *back, int sx, int sy, int dir, int dx, int dy, int ddir, double we, double wc, int *o_en, int *o_t, int *o_dir)
{
  struct Heap *heap;
  int exit=-1;
  int prvy=-1;


  struct Policko *p;
  struct Policko ps;
  
  _printf("Hladam z [%d,%d] do [%d,%d]...\n", sx, sy, dx, dy);
  fflush(stdout);
  heap=heap_new(hl_cmp, free);
  
  _printf("foo\n");

  memset(pol, 0, sizeof(pol));
  memset(dis_en, 0x3f, sizeof(dis_en));
  memset(dis_t, 0x3f, sizeof(dis_t));

  _printf("goo %d\n", dis_en[0][0][0]);
  fflush(stdout);

  sx+=MAX_BOARD_SIZE+25;
  sy+=MAX_BOARD_SIZE+25;
  dx+=MAX_BOARD_SIZE+25;
  dy+=MAX_BOARD_SIZE+25;
  
  hl_insert(sx, sy, dir, 0, 0, TP_TAH_NIC, TP_TAH_NIC, heap, we, wc);
  dis_en[sx][sy][dir]=0;
  dis_t[sx][sy][dir]=0;

  while(exit<0 && (p=heap_extract(heap)))
  {
    memcpy(&ps, p, sizeof(struct Policko));
    heap_delete(heap);
    p=&ps;

    dis_en[p->x][p->y][p->dir]=p->en;
    dis_t[p->x][p->y][p->dir]=p->t;
    if(back)
      (*back)[p->x][p->y][p->dir]=p->tah;

    if(p->x==dx && p->y==dy && (ddir<0 || ddir==p->dir))
    {
      exit=p->dir;
      prvy=p->prvytah;
      break;
    }

    if(pole_mozme[p->x][p->y])
      hl_insert(p->x, p->y, (p->dir+1)%8, p->en+TANK_EN_OTOC+bager_en(p->x, p->y, (p->dir+1)%8), p->t+TANK_CAS_OTOC+bager_t(p->x, p->y, (p->dir+1)%8), p->prvytah==TP_TAH_NIC?TP_TAH_DOPRAVA:p->prvytah, TP_TAH_DOPRAVA, heap, we, wc);
    if(pole_mozme[p->x][p->y])
      hl_insert(p->x, p->y, (p->dir+7)%8, p->en+TANK_EN_OTOC+bager_en(p->x, p->y, (p->dir+7)%8), p->t+TANK_CAS_OTOC+bager_t(p->x, p->y, (p->dir+7)%8), p->prvytah==TP_TAH_NIC?TP_TAH_DOLAVA:p->prvytah, TP_TAH_DOLAVA, heap, we, wc);

    if(pole_mozme[p->x+smer_x[p->dir]][p->y+smer_y[p->dir]])
      hl_insert(p->x+smer_x[p->dir], p->y+smer_y[p->dir], p->dir, p->en+TANK_EN_DOPREDU+bager_en(p->x+smer_x[p->dir], p->y+smer_y[p->dir], p->dir), p->t+TANK_CAS_DOPREDU+bager_t(p->x+smer_x[p->dir], p->y+smer_y[p->dir], p->dir), p->prvytah==TP_TAH_NIC?TP_TAH_DOPREDU:p->prvytah, TP_TAH_DOPREDU, heap, we, wc);
    if(pole_mozme[p->x-smer_x[p->dir]][p->y-smer_y[p->dir]])
      hl_insert(p->x-smer_x[p->dir], p->y-smer_y[p->dir], p->dir, p->en+TANK_EN_DOZADU+bager_en(p->x-smer_x[p->dir], p->y-smer_y[p->dir], p->dir), p->t+TANK_CAS_DOZADU+bager_t(p->x-smer_x[p->dir], p->y-smer_y[p->dir], p->dir), p->prvytah==TP_TAH_NIC?TP_TAH_DOZADU:p->prvytah, TP_TAH_DOZADU, heap, we, wc);
  }

  heap_free(heap);

  if(exit<0)
    return -1;

  *o_en=dis_en[dx][dy][exit];
  *o_t=dis_t[dx][dy][exit];
  *o_dir=exit;
  
  switch(prvy)
  {
    case TP_TAH_DOLAVA:
      _printf("Energia potrebna pre tah DOLAVA: %d", dis_en[sx][sy][(dir+7)%8]);
      break;
    case TP_TAH_DOPRAVA:
      _printf("Energia potrebna pre tah DOPRAVA: %d", dis_en[sx][sy][(dir+1)%8]);
      break;
    case TP_TAH_DOPREDU:
      _printf("Energia potrebna pre tah DOPREDU: %d", dis_en[sx+smer_x[dir]][sy+smer_y[dir]][dir]);
      break;
    case TP_TAH_DOZADU:
      _printf("Energia potrebna pre tah DOZADU: %d", dis_en[sx-smer_x[dir]][sy-smer_y[dir]][dir]);
      break;
  }
  _printf(", celkova energia potrebna na navrat %d\n", *o_en);
  
  return prvy;
}


int max(int x, int y)
{
  return (x>y)?x:y;
}


int zmen_stav()
{
  int i, j;
  int t, dir;

  switch(stav_hry)
  {
    case STAV_HLADANIE:
      if(10*ja->hp<7*TANK_HP)
      {
        _printf("Malo HP -> smer domcek\n");
        mapa_zmena=1;
        _sleep(3);
        return STAV_DOMCEK;
      }

      return_en+=4*TANK_EN_BAGER+TANK_EN_DOZADU;
      if(5*return_en+2500>4*ja->en)
        hladaj(NULL, ja->poz.x, ja->poz.y, ja->dir, 0, 0, -1, 1, 0, &return_en, &t, &dir);
        
      _printf("Potrebna energia na vratenie do domceka:\t\t\t%d, cas %d\n", return_en, t);
      if(5*return_en+2500>4*ja->en)
      {
        _printf("Menim stav, idem do domceka\n");
        mapa_zmena=1;
        _sleep(3);
        return STAV_DOMCEK;
      }
      
      j=1;
      for(i=2; i<=MAX_PLAYERS; i++)
        if(j==player_number||(i!=player_number && hraci_kedy[i]<hraci_kedy[j] && (!hraci_dom[j].number || max(abs(hraci_kde[j].poz.x-hraci_dom[j].poz.x), abs(hraci_kde[j].poz.y-hraci_dom[j].poz.y))>=6)))
          j=i;
      
      enemy=&hraci_kde[j];
      if(j!=player_number && 2*ja->en>TANK_EN && hraci_kedy[j]-cas<10 && (!hraci_dom[j].number || max(abs(hraci_kde[j].poz.x-hraci_dom[j].poz.x), abs(hraci_kde[j].poz.y-hraci_dom[j].poz.y))>=6))
      {
        _printf("Spozorovany nepriatel - UTOK!!!\n");
        _sleep(3);
        return STAV_UTOK;
      }
      
      return STAV_HLADANIE;
      break;
    case STAV_UTOK:
      if(hraci_kedy[enemy->number]-cas>30)
      {
        _printf("Nepriatel unikol -> pokracujeme v hladani\n");
        if(ciel)
          free(ciel);
        ciel=NULL;
        _sleep(3);
        return STAV_HLADANIE;
      }
      
      if(10*ja->en<TANK_EN || (4*ja->hp<3*enemy->hp && 4*ja->hp>TANK_HP))
      {
        _printf("Malo energie/HP -> smer domcek\n");
        mapa_zmena=1;
        _sleep(3);
        return STAV_DOMCEK;
      }

      if(max(abs(enemy->poz.x-hraci_dom[enemy->number].poz.x), abs(enemy->poz.y-hraci_dom[enemy->number].poz.y))<6)
      {
        _printf("Utek z boja\n");
        mapa_zmena=1;
        _sleep(3);
        return STAV_DOMCEK;
      }
      
      return STAV_UTOK;
      break;
    case STAV_DOMCEK:
      j=1;
      for(i=2; i<=MAX_PLAYERS; i++)
        if(j==player_number||(i!=player_number && hraci_kedy[i]<hraci_kedy[j] && (!hraci_dom[j].number || max(abs(hraci_kde[j].poz.x-hraci_dom[j].poz.x), abs(hraci_kde[j].poz.y-hraci_dom[j].poz.y))>=6)))
          j=i;
      
      enemy=&hraci_kde[j];
      if(j!=player_number && 2*ja->en>TANK_EN && hraci_kedy[j]-cas==0 && (!hraci_dom[j].number || max(abs(hraci_kde[j].poz.x-hraci_dom[j].poz.x), abs(hraci_kde[j].poz.y-hraci_dom[j].poz.y))>=6))
      {
        _printf("Spozorovany narusitel - UTOK!!!\n");
        _sleep(3);
        return STAV_UTOK;
      }


      if(ja->en>=TANK_EN-50 && ja->hp>=TANK_HP-50)
      {
        if(ciel)
          free(ciel);
        ciel=NULL;
        return STAV_HLADANIE;
      }
      
      return STAV_DOMCEK;
      break;
  }

  _printf("Oops - zly stav\n");
  exit(1);
}


int okolo(int x, int y, int co)
{
  int i;

  for(i=0; i<8; i++)
    if(MAPA(x+smer_x[i], y+smer_y[i])==co)
      return 1;
  return 0;
}


struct TPoint *mkrandciel()
{
  struct TPoint *c;
  double best, now;
  int i, j;
  
  c=malloc(sizeof(struct TPoint));
  best=-1000000;
  
  FORMAPA(i,j)
    if(i!=ja->poz.x || j!=ja->poz.y)
  {
    if(MOZME(i,j) && okolo(i,j,M_NEVIEM) && MAPA(i,j)==M_TRAVA)
      now=(double)(1000-rand()%200)/(double)max(abs(i-ja->poz.x), abs(j-ja->poz.y))*1.1;
     else
    if(MOZME(i,j) && okolo(i,j,M_NEVIEM))
      now=(double)(1000-rand()%200)/(double)max(abs(i-ja->poz.x), abs(j-ja->poz.y));
     else
    if(MOZME(i,j) && MAPA(i,j)==M_TRAVA && max(abs(i-ja->poz.x), abs(j-ja->poz.y))>15)
      now=(double)(1000-rand()%200)/(double)max(abs(i-ja->poz.x), abs(j-ja->poz.y))-5000;
     else
    if(MOZME(i,j) && max(abs(i-ja->poz.x), abs(j-ja->poz.y))>15)
      now=(double)(1000-rand()%200)/(double)max(abs(i-ja->poz.x), abs(j-ja->poz.y))-50000;
     else
    if(MOZME(i,j))
      now=(double)(1000-rand()%200)/(double)max(abs(i-ja->poz.x), abs(j-ja->poz.y))-80000;
     else
      now=-2000000;
      
    if(now>best)
    {
      best=now;
      c->x=i;
      c->y=j;
      _printf("Novy ciel - x=%d y=%d  best=%f\n", c->x, c->y, best);
    }
  }
  
  _printf("Generujem ciel: %d %d\n", c->x, c->y);
  return c;
}


int stav_hladaj()
{
  int en, t, res;
  int x, y, dir;

  if(ciel && ciel->x==ja->poz.x && ciel->y==ja->poz.y)
  {
    free(ciel);
    ciel=NULL;
  }

  if(ciel && !MOZME(ciel->x, ciel->y))
  {
    free(ciel);
    ciel=NULL;
  }

  if(!ciel)
  {
    ciel=mkrandciel();
    mapa_zmena=1;
  }

  _printf("Ciel: %d %d\n", ciel->x, ciel->y);
  
  if(mapa_zmena)
    res=hladaj(&ciel_cesta, ja->poz.x, ja->poz.y, ja->dir, ciel->x, ciel->y, -1, 0, 1, &en, &t, &ciel_dir);
   else
  {
    x=ciel->x;
    y=ciel->y;
    dir=ciel_dir;
    
    res=TP_TAH_NIC;
    while(x!=ja->poz.x || y!=ja->poz.y || dir!=ja->dir)
    {
      switch((res=ciel_cesta[x+MAX_BOARD_SIZE+25][y+MAX_BOARD_SIZE+25][dir]))
      {
        case TP_TAH_DOLAVA:
          dir=(dir+1)%8;
          break;
        case TP_TAH_DOPRAVA:
          dir=(dir+7)%8;
          break;
        case TP_TAH_DOPREDU:
          x-=smer_x[dir];
          y-=smer_y[dir];
          break;
        case TP_TAH_DOZADU:
          x+=smer_x[dir];
          y+=smer_y[dir];
          break;
        default:
          _printf("Oops: zly tah\n");
      }
    }
  }
  
  _printf("Hladaj: %d\n", res);
  mapa_zmena=0;
  showmap();
  return res;
}


int nadostrel(int nx, int ny, int md, int x, int y, int d)
{
  int buram;
  int res=0;
  int k;
  int mx, my;
  
  nx+=2*smer_x[md];
  ny+=2*smer_y[md];

  for(k=-2; k<=2; k++)
  {
    mx=nx;
    my=ny;
    buram=0;
    while(buram<=0 && max(abs(mx-x), abs(my-y))<20)
    {
      if(abs(mx-x-k*smer_x[d])<=2 && abs(my-y-k*smer_y[d])<=2 && tankTvary[d][2+my-y-k*smer_y[d]][2+mx-x-k*smer_x[d]])
      {
        res++;
        break;
      }
    
      mx+=smer_x[md];
      my+=smer_y[md];

      if(MAPA(mx, my)==M_TRAVA)
        buram++;
    }
  }
  
  return res;
}


int stav_utok()
{
  int i, j, k;
  int x, y, dir;
  int en, t, res, hits, nh;

  x=y=47;
  dir=-1;

  for(i=-10; i<=10; i++)
    for(j=-10; j<=10; j++)
      for(k=0; k<8; k++)
        if(MOZME(enemy->poz.x+i,enemy->poz.y+j))
          if(nadostrel(enemy->poz.x+i,enemy->poz.y+j,k,enemy->poz.x, enemy->poz.y, enemy->dir))
            if(max(abs(i),abs(j))<max(abs(x),abs(y)))
  {
    x=i;
    y=j;
    dir=k;
  }
  
  if(x==47)
  {
    showmap();
    _printf("NIC NA DOSTREL !!!!!!!!!!!!!!\n");
    _sleep(3);
    return TP_TAH_NIC;
  }
  
  x+=enemy->poz.x;
  y+=enemy->poz.y;
  
  hladaj(&ciel_cesta, ja->poz.x, ja->poz.y, ja->dir, x, y, dir, 0, 1, &en, &t, &ciel_dir);

  t=1000000000;
  hits=0;

  for(i=-10; i<=10; i++)
    for(j=-10; j<=10; j++)
      for(k=0; k<8; k++)
        if(MOZME(enemy->poz.x+i,enemy->poz.y+j))
          if((nh=nadostrel(enemy->poz.x+i,enemy->poz.y+j,k,enemy->poz.x, enemy->poz.y, enemy->dir)))
            if(dis_t[enemy->poz.x+i+MAX_BOARD_SIZE+25][enemy->poz.y+j+MAX_BOARD_SIZE+25][k]<1000000)
    if(nh>hits || (nh==hits && t>dis_t[enemy->poz.x+i+MAX_BOARD_SIZE+25][enemy->poz.y+j+MAX_BOARD_SIZE+25][k]))
  {
    x=enemy->poz.x+i;
    y=enemy->poz.y+j;
    dir=k;
    t=dis_t[enemy->poz.x+i+MAX_BOARD_SIZE+25][enemy->poz.y+j+MAX_BOARD_SIZE+25][k];
    hits=nh;
  }

  if(!hits)
    return TP_TAH_NIC;

  res=TP_TAH_NIC;
  while(x!=ja->poz.x || y!=ja->poz.y || dir!=ja->dir)
  {
    switch((res=ciel_cesta[x+MAX_BOARD_SIZE+25][y+MAX_BOARD_SIZE+25][dir]))
    {
      case TP_TAH_DOLAVA:
        dir=(dir+1)%8;
        break;
      case TP_TAH_DOPRAVA:
        dir=(dir+7)%8;
        break;
      case TP_TAH_DOPREDU:
        x-=smer_x[dir];
        y-=smer_y[dir];
        break;
      case TP_TAH_DOZADU:
        x+=smer_x[dir];
        y+=smer_y[dir];
        break;
      default:
        _printf("Oops: zly tah\n");
    }
  }

  if(res==TP_TAH_NIC)
    res=TP_TAH_DOPREDU;

  mapa_zmena=0;
  showmap();
  return res;
}


int stav_domcek()
{
  int en, t, res;
  int x, y, dir;

  if(mapa_zmena)
    res=hladaj(&ciel_cesta, ja->poz.x, ja->poz.y, ja->dir, 0, 0, -1, 1, 0, &en, &t, &ciel_dir);
   else
  {
    x=0;
    y=0;
    dir=ciel_dir;
    
    res=TP_TAH_NIC;
    while(x!=ja->poz.x || y!=ja->poz.y || dir!=ja->dir)
    {
      switch((res=ciel_cesta[x+MAX_BOARD_SIZE+25][y+MAX_BOARD_SIZE+25][dir]))
      {
        case TP_TAH_DOLAVA:
          dir=(dir+1)%8;
          break;
        case TP_TAH_DOPRAVA:
          dir=(dir+7)%8;
          break;
        case TP_TAH_DOPREDU:
          x-=smer_x[dir];
          y-=smer_y[dir];
          break;
        case TP_TAH_DOZADU:
          x+=smer_x[dir];
          y+=smer_y[dir];
          break;
        default:
          _printf("Oops: zly tah\n");
      }
    }
  }

  
  _printf("Domcek: %d\n", res);
  mapa_zmena=0;
  showmap();
  return res;
}


int vratTah()
{
  _printf("Som na [%d,%d], smer %d, stav %d\n", ja->poz.x, ja->poz.y, ja->dir, stav_hry);
  stav_hry=zmen_stav();
  _printf("Novy stav %d\n", stav_hry);
  
  switch(stav_hry)
  {
    case STAV_HLADANIE:
      return stav_hladaj();
    case STAV_UTOK:
      return stav_utok();
    case STAV_DOMCEK:
      return stav_domcek();
  }
  
  mapa_zmena=0;
  showmap();
  return TP_TAH_NIC;
}


int mamStrelit()
{
  int i;

  if(return_en+500>ja->en)
    return 0;

  for(i=1; i<=MAX_PLAYERS; i++)
    if(i!=player_number && hraci_kde[i].number && hraci_kedy[i]-cas<5)
      if(nadostrel(ja->poz.x, ja->poz.y, ja->dir, hraci_kde[i].poz.x, hraci_kde[i].poz.y, hraci_kde[i].dir))
        return 1;

  return 0;
}


char *vratHlasku()
{
  return "";
}
