unit player;
interface
uses types;

procedure init;
procedure done;
procedure novyStav( const stav:TStav);
function vratTah:integer;
function mamStrelit:boolean;

//hlaska nesmie obsahovat obsahovat znaky noveho riadku
function vratHlasku:string;

implementation
uses video, keyboard, linux, crt, sysutils,
     config;

var lastNow : TDateTime;
    tah : integer;
    strielat : boolean;

function now_msec:double;
var hour, min, sec, msec : word;
begin
  getTime(hour, min, sec, msec);
  now_msec:= date + (hour*60*60 + min*60 + sec + msec/100.0)/(24*60*60);
end;

procedure textOut(x,y:word; const s:string);  //z dokumentacie
var p,m,i: word;
begin
  p:=(x-1)+(y-1)*screenwidth;
  m:=length(s);
  if m+x>=screenwidth then
    m:=screenwidth-x;
  for i:=1 to m do
    videobuf^[p+i-1]:=ord(s[i])+($07 shr 8);
end;

procedure init;
begin
  InitVideo;
  InitKeyboard;

  lastNow:=now_msec;

  tah:=TP_TAH_NIC;
  strielat:=false;
end;

procedure done;
begin
  DoneVideo;
  DoneKeyboard;
end;

procedure novyStav( const stav:TStav);
var pis_y, i, j : integer;
begin
  with stav do begin
    SetCursorPos( 1,0 );
    writeln(' Cas ',cas:4);

    for i:=1 to STAV_STRANA do begin
      for j:=1 to STAV_STRANA do
        write(vidim[i][j]);
      writeln;
    end;

    pis_y:=1;
    for i:=1 to objekty_pocet do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      case objekty[i].typ of
        objTank   :
          with objekty[i].tank do begin
            writeln('Hrac ',number,':  poz ',poz.x:3,',',poz.y:3,'  smer ',dir,'  spi ',spi,'       ');
            SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
            writeln('         EN ',en:4,'  HP ',hp:4,'  striel ', striel,'          ');
          end;
        objStrela :
          with objekty[i].strela do
            writeln('Strela : pos ',poz.x:3,',',poz.y:3, '  smer ',dir,'  vlastnik ',number,'           ');
        objDom :
          with objekty[i].dom do
            writeln('Dom ',number,': pos ',poz.x:3,',',poz.y:3, '  vlastnik ',number,'           ');
        else
          writeln('Neosetreny objekt                                        ');
      end;
    end;
    for i:=objekty_pocet to STAV_STRANA+1 do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      writeln('                                              ');
    end;

  SetCursorPos( 1, STAV_STRANA+1);
  with ja do 
    writeln('EN ',en:4,'  HP ',hp:4, '  spi ',spi:2, '  striel ',striel:2, '                   ');
  writeln(' domov ',domov.x:3,', ',domov.y:3, '                          ');
 
  end;

  while (now_msec<=(lastNow+0.05/(24*60*60))) do
    delay(10);
  lastNow:=now_msec;
end; 


procedure handleKeyboard;
var k:TKeyEvent;

begin
  while PollKeyEvent<>0 do begin
    k:=getKeyEvent;
    k:=translateKeyEvent(k);

    case k of
      33619745 : tah:= TP_TAH_DOPREDU;
      33619751 : tah:= TP_TAH_DOZADU;
      33619747 : tah:= TP_TAH_DOLAVA;
      33619749 : tah:= TP_TAH_DOPRAVA;

      14624    : strielat:= true;   //space

      4209,     //q,Q
      4177     : halt;
    end;
  end;
end;


function vratTah:integer;
begin
  handleKeyboard;
  vratTah:=tah;
  tah:=TP_TAH_NIC;
  tah:=TP_TAH_NIC;
//  tah:=TP_TAH_DOPREDU;  //ak sa chces ist dopredu bez stlacania sipky hore
end;

function mamStrelit:boolean;
begin
  handleKeyboard;
  mamStrelit:=strielat;
  strielat:=false;
end;

function vratHlasku:string;
begin
	vratHlasku:='';
end;

end.
